
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java中的ReentrantLock和synchronized两种锁机制的对比 / iVAN</title>

    <meta name="description" content="Java中的ReentrantLock和synchronized两种锁机制的对比 原文:http://www.ibm.com/developerworks/cn/java/j-jtp10264/index.html 多线程和并发性并不是什么新内容,但是 Java 语言设计中的创新之一就是,它是第一个直接把跨平台线程模型和正规的内存模型集成到语言中的主流语言.核心类库包含一个 Thread 类,可以用它来构建.启动和操纵线程,Java 语言包括了跨线程传达并发性约束的构造 -- synchronized 和 volatile.在简化与平台无关的并发类的开发的同时,它决没有使并发">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java中的ReentrantLock和synchronized两种锁机制的对比</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文：<a href="http://www.ibm.com/developerworks/cn/java/j-jtp10264/index.html" rel="external nofollow noreferrer">http://www.ibm.com/developerworks/cn/java/j-jtp10264/index.html</a></p>
<p>多线程和并发性并不是什么新内容，但是 Java 语言设计中的创新之一就是，它是第一个直接把跨平台线程模型和正规的内存模型集成到语言中的主流语言。核心类库包含一个 <code>Thread</code> 类，可以用它来构建、启动和操纵线程，Java 语言包括了跨线程传达并发性约束的构造 —— <code>synchronized</code> 和 <code>volatile</code>。在简化与平台无关的并发类的开发的同时，它决没有使并发类的编写工作变得更繁琐，只是使它变得更容易了。</p>
<p><a><strong>synchronized 快速回顾</strong></a></p>
<p>把代码块声明为 synchronized，有两个重要后果，通常是指该代码具有 <em>原子性（atomicity）</em>和 <em>可见性（visibility）</em>。原子性意味着一个线程一次只能执行由一个指定监控对象（lock）保护的代码，从而防止多个线程在更新共享状态时相互冲突。可见性则更为微妙；它要对付内存缓存和编译器优化的各种反常行为。一般来说，线程以某种不必让其他线程立即可以看到的方式（不管这些线程在寄存器中、在处理器特定的缓存中，还是通过指令重排或者其他编译器优化），不受缓存变量值的约束，但是如果开发人员使用了同步，如下面的代码所示，那么运行库将确保某一线程对变量所做的更新先于对现有<code>synchronized</code> 块所进行的更新，当进入由同一监控器（lock）保护的另一个 <code>synchronized</code> 块时，将立刻可以看到这些对变量所做的更新。类似的规则也存在于 <code>volatile</code> 变量上。</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/fw0124/article/details/6672522#" rel="external nofollow noreferrer">view<br />
 plain</a> <a href="http://blog.csdn.net/fw0124/article/details/6672522#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>synchronized (lockObject) {   </li>
<li>  // update object state  </li>
<li>}  </li>
</ol>
<p>所以，实现同步操作需要考虑安全更新多个共享变量所需的一切，不能有争用条件，不能破坏数据（假设同步的边界位置正确），而且要保证正确同步的其他线程可以看到这些变量的最新值。通过定义一个清晰的、跨平台的内存模型（该模型在 JDK 5.0 中做了修改，改正了原来定义中的某些错误），通过遵守下面这个简单规则，构建“一次编写，随处运行”的并发类是有可能的：</p>
<blockquote><p>不论什么时候，只要您将编写的变量接下来可能被另一个线程读取，或者您将读取的变量最后是被另一个线程写入的，那么您必须进行同步。</p></blockquote>
<p>不过现在好了一点，在最近的 JVM 中，没有争用的同步（一个线程拥有锁的时候，没有其他线程企图获得锁）的性能成本还是很低的。（也不总是这样；早期 JVM 中的同步还没有优化，所以让很多人都这样认为，但是现在这变成了一种误解，人们认为不管是不是争用，同步都有很高的性能成本。）</p>
<hr>
<p><a><strong>对 synchronized 的改进</strong></a></p>
<p>如此看来同步相当好了，是么？那么为什么 JSR 166 小组花了这么多时间来开发 <code>java.util.concurrent.lock</code> 框架呢？答案很简单－同步是不错，但它并不完美。它有一些功能性的限制 —— 它无法中断一个正在等候获得锁的线程，也无法通过投票得到锁，如果不想等下去，也就没法得到锁。同步还要求锁的释放只能在与获得锁所在的堆栈帧相同的堆栈帧中进行，多数情况下，这没问题（而且与异常处理交互得很好），但是，确实存在一些非块结构的锁定更合适的情况。</p>
<p><a><strong>ReentrantLock 类</strong></a></p>
<p><code>java.util.concurrent.lock</code> 中的 <code>Lock</code> 框架是锁定的一个抽象，它允许把锁定的实现作为 Java 类，而不是作为语言的特性来实现。这就为 <code>Lock</code> 的多种实现留下了空间，各种实现可能有不同的调度算法、性能特性或者锁定语义。 <code>ReentrantLock</code> 类实现了 <code>Lock</code> ，它拥有与 <code>synchronized</code> 相同的并发性和内存语义，但是添加了类似锁投票、定时锁等候和可中断锁等候的一些特性。此外，它还提供了在激烈争用情况下更佳的性能。（换句话说，当许多线程都想访问共享资源时，JVM<br />
 可以花更少的时候来调度线程，把更多时间用在执行线程上。）</p>
<p><em>reentrant</em> 锁意味着什么呢？简单来说，它有一个与锁相关的获取计数器，如果拥有锁的某个线程再次得到锁，那么获取计数器就加1，然后锁需要被释放两次才能获得真正释放。这模仿了 <code>synchronized</code> 的语义；如果线程进入由线程已经拥有的监控器保护的 synchronized 块，就允许线程继续进行，当线程退出第二个（或者后续） <code>synchronized</code> 块的时候，不释放锁，只有线程退出它进入的监控器保护的第一个 <code>synchronized</code> 块时，才释放锁。</p>
<p>在查看清单 1 中的代码示例时，可以看到 <code>Lock</code> 和 synchronized 有一点明显的区别 —— lock 必须在 finally 块中释放。否则，如果受保护的代码将抛出异常，锁就有可能永远得不到释放！这一点区别看起来可能没什么，但是实际上，它极为重要。忘记在 finally 块中释放锁，可能会在程序中留下一个定时炸弹，当有一天炸弹爆炸时，您要花费很大力气才有找到源头在哪。而使用同步，JVM 将确保锁会获得自动释放。</p>
<p><a><strong>清单 1. 用 ReentrantLock 保护代码块。</strong></a></p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/fw0124/article/details/6672522#" rel="external nofollow noreferrer">view<br />
 plain</a> <a href="http://blog.csdn.net/fw0124/article/details/6672522#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>Lock lock = new ReentrantLock();  </li>
<li>lock.lock();  </li>
<li>try {   </li>
<li>  // update object state  </li>
<li>}  </li>
<li>finally {  </li>
<li>  lock.unlock();   </li>
<li>}  </li>
</ol>
<p>除此之外，与目前的 synchronized 实现相比，争用下的 <code>ReentrantLock</code> 实现更具可伸缩性。（在未来的 JVM 版本中，synchronized 的争用性能很有可能会获得提高。）这意味着当许多线程都在争用同一个锁时，使用 <code>ReentrantLock</code> 的总体开支通常要比 <code>synchronized</code> 少得多。</p>
<hr>
<p><a><strong>比较 ReentrantLock 和 synchronized 的可伸缩性</strong></a></p>
<p>Tim Peierls 用一个简单的线性全等伪随机数生成器（PRNG）构建了一个简单的评测，用它来测量 <code>synchronized</code> 和 <code>Lock</code> 之间相对的可伸缩性。这个示例很好，因为每次调用 <code>nextRandom()</code> 时，PRNG 都确实在做一些工作，所以这个基准程序实际上是在测量一个合理的、真实的 <code>synchronized</code> 和 <code>Lock</code> 应用程序，而不是测试纯粹纸上谈兵或者什么也不做的代码（就像许多所谓的基准程序一样。）</p>
<p>在这个基准程序中，有一个 <code>PseudoRandom</code> 的接口，它只有一个方法 <code>nextRandom(int bound)</code> 。该接口与 <code>java.util.Random</code> 类的功能非常类似。因为在生成下一个随机数时，PRNG 用最新生成的数字作为输入，而且把最后生成的数字作为一个实例变量来维护，其重点在于让更新这个状态的代码段不被其他线程抢占，所以我要用某种形式的锁定来确保这一点。（ <code>java.util.Random</code> 类也可以做到这点。）我们为 <code>PseudoRandom</code> 构建了两个实现；一个使用<br />
 syncronized，另一个使用 <code>java.util.concurrent.ReentrantLock</code> 。驱动程序生成了大量线程，每个线程都疯狂地争夺时间片，然后计算不同版本每秒能执行多少轮。图 1 和 图 2 总结了不同线程数量的结果。这个评测并不完美，而且只在两个系统上运行了（一个是双 Xeon 运行超线程 Linux，另一个是单处理器 Windows 系统），但是，应当足以表现 <code>synchronized</code> 与 <code>ReentrantLock</code> 相比所具有的伸缩性优势了。</p>
<p><a><strong><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGkuY3Nkbi5uZXQvYXR0YWNobWVudC8yMDExMDgvOS8wXzEzMTI4NzMxMjRyNlFaLmdpZg==.jpg"></strong></a></p>
<p>图 1 和图 2 中的图表以每秒调用数为单位显示了吞吐率，把不同的实现调整到 1 线程 <code>synchronized</code> 的情况。每个实现都相对迅速地集中在某个稳定状态的吞吐率上，该状态通常要求处理器得到充分利用，把大多数的处理器时间都花在处理实际工作（计算机随机数）上，只有小部分时间花在了线程调度开支上。您会注意到，synchronized 版本在处理任何类型的争用时，表现都相当差，而 <code>Lock</code> 版本在调度的开支上花的时间相当少，从而为更高的吞吐率留下空间，实现了更有效的<br />
 CPU 利用。</p>
<hr>
<p><a><strong>条件变量</strong></a></p>
<p>根类 <code>Object</code> 包含某些特殊的方法，用来在线程的 <code>wait()</code> 、 <code>notify()</code> 和 <code>notifyAll()</code> 之间进行通信。这些是高级的并发性特性，许多开发人员从来没有用过它们 —— 这可能是件好事，因为它们相当微妙，很容易使用不当。幸运的是，随着 JDK 5.0 中引入 <code>java.util.concurrent</code> ，开发人员几乎更加没有什么地方需要使用这些方法了。</p>
<p>通知与锁定之间有一个交互 —— 为了在对象上 <code>wait</code> 或 <code>notify</code> ，您必须持有该对象的锁。就像 <code>Lock</code> 是同步的概括一样， <code>Lock</code> 框架包含了对 <code>wait</code> 和<code>notify</code> 的概括，这个概括叫作 <code>条件（Condition）</code> 。 <code>Lock</code> 对象则充当绑定到这个锁的条件变量的工厂对象，与标准的 <code>wait</code> 和 <code>notify</code> 方法不同，对于指定的 <code>Lock</code> ，可以有不止一个条件变量与它关联。这样就简化了许多并发算法的开发。例如， <code>条件（Condition）</code> 的<br />
 Javadoc 显示了一个有界缓冲区实现的示例，该示例使用了两个条件变量，“not full”和“not empty”，它比每个 lock 只用一个 wait 设置的实现方式可读性要好一些（而且更有效）。 <code>Condition</code>的方法与 <code>wait</code> 、 <code>notify</code> 和 <code>notifyAll</code> 方法类似，分别命名为 <code>await</code> 、 <code>signal</code> 和 <code>signalAll</code> ，因为它们不能覆盖 <code>Object</code> 上的对应方法。</p>
<hr>
<p><a><strong>这不公平</strong></a></p>
<p>如果查看 Javadoc，您会看到， <code>ReentrantLock</code> 构造器的一个参数是 boolean 值，它允许您选择想要一个 <em>公平（fair）</em>锁，还是一个 <em>不公平（unfair）</em>锁。公平锁使线程按照请求锁的顺序依次获得锁；而不公平锁则允许讨价还价，在这种情况下，线程有时可以比先请求锁的其他线程先得到锁。</p>
<p>为什么我们不让所有的锁都公平呢？毕竟，公平是好事，不公平是不好的，不是吗？（当孩子们想要一个决定时，总会叫嚷“这不公平”。我们认为公平非常重要，孩子们也知道。）在现实中，公平保证了锁是非常健壮的锁，有很大的性能成本。要确保公平所需要的记帐（bookkeeping）和同步，就意味着被争夺的公平锁要比不公平锁的吞吐率更低。作为默认设置，应当把公平设置为 <code>false</code> ，除非公平对您的算法至关重要，需要严格按照线程排队的顺序对其进行服务。</p>
<p>那么同步又如何呢？内置的监控器锁是公平的吗？答案令许多人感到大吃一惊，它们是不公平的，而且永远都是不公平的。但是没有人抱怨过线程饥渴，因为 JVM 保证了所有线程最终都会得到它们所等候的锁。确保统计上的公平性，对多数情况来说，这就已经足够了，而这花费的成本则要比绝对的公平保证的低得多。所以，默认情况下 <code>ReentrantLock</code> 是“不公平”的，这一事实只是把同步中一直是事件的东西表面化而已。如果您在同步的时候并不介意这一点，那么在 <code>ReentrantLock</code> 时也不必为它担心。</p>
<p>图 3 和图 4 包含与 图 1和 图 2 相同的数据，只是添加了一个数据集，用来进行随机数基准检测，这次检测使用了公平锁，而不是默认的协商锁。正如您能看到的，公平是有代价的。如果您需要公平，就必须付出代价，但是请不要把它作为您的默认选择。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGkuY3Nkbi5uZXQvYXR0YWNobWVudC8yMDExMDgvOS8wXzEzMTI4NzMxMzF5WnpPLmdpZg==.jpg"></p>
<hr>
<p><a><strong>处处都好？</strong></a></p>
<p>看起来 <code>ReentrantLock</code> 无论在哪方面都比 <code>synchronized</code> 好 —— 所有 <code>synchronized</code> 能做的，它都能做，它拥有与 <code>synchronized</code> 相同的内存和并发性语义，还拥有 <code>synchronized</code> 所没有的特性，在负荷下还拥有更好的性能。那么，我们是不是应当忘记 <code>synchronized</code> ，不再把它当作已经已经得到优化的好主意呢？或者甚至用 <code>ReentrantLock</code> 重写我们现有的 <code>synchronized</code> 代码？实际上，几本<br />
 Java 编程方面介绍性的书籍在它们多线程的章节中就采用了这种方法，完全用 <code>Lock</code> 来做示例，只把 synchronized 当作历史。但我觉得这是把好事做得太过了。</p>
<p><a><strong>还不要抛弃 synchronized</strong></a></p>
<p>虽然 <code>ReentrantLock</code> 是个非常动人的实现，相对 synchronized 来说，它有一些重要的优势，但是我认为急于把 synchronized 视若敝屣，绝对是个严重的错误。 <em><code>java.util.concurrent.lock </code>中的锁定类是用于高级用户和高级情况的工具 </em>。一般来说，除非您对 <code>Lock</code> 的某个高级特性有明确的需要，或者有明确的证据（而不是仅仅是怀疑）表明在特定情况下，同步已经成为可伸缩性的瓶颈，否则还是应当继续使用<br />
 synchronized。</p>
<p>为什么我在一个显然“更好的”实现的使用上主张保守呢？因为对于 <code>java.util.concurrent.lock</code> 中的锁定类来说，synchronized 仍然有一些优势。比如，在使用 synchronized 的时候，不能忘记释放锁；在退出 <code>synchronized</code> 块时，JVM 会为您做这件事。您很容易忘记用 <code>finally</code> 块释放锁，这对程序非常有害。您的程序能够通过测试，但会在实际工作中出现死锁，那时会很难指出原因（这也是为什么根本不让初级开发人员使用 <code>Lock</code> 的一个好理由。）</p>
<p>另一个原因是因为，当 JVM 用 synchronized 管理锁定请求和释放时，JVM 在生成线程转储时能够包括锁定信息。这些对调试非常有价值，因为它们能标识死锁或者其他异常行为的来源。 <code>Lock</code> 类只是普通的类，JVM 不知道具体哪个线程拥有 <code>Lock</code> 对象。而且，几乎每个开发人员都熟悉 synchronized，它可以在 JVM 的所有版本中工作。在 JDK 5.0 成为标准（从现在开始可能需要两年）之前，使用 <code>Lock</code> 类将意味着要利用的特性不是每个<br />
 JVM 都有的，而且不是每个开发人员都熟悉的。</p>
<p><a><u><strong>什么时候选择用 ReentrantLock 代替 synchronized</strong></u></a></p>
<p>既然如此，我们什么时候才应该使用 <code>ReentrantLock</code> 呢？答案非常简单 —— 在确实需要一些 synchronized 所没有的特性的时候，比如时间锁等候、可中断锁等候、无块结构锁、多个条件变量或者锁投票。 <code>ReentrantLock</code> 还具有可伸缩性的好处，应当在高度争用的情况下使用它，但是请记住，大多数 synchronized 块几乎从来没有出现过争用，所以可以把高度争用放在一边。我建议用 synchronized 开发，直到确实证明 synchronized<br />
 不合适，而不要仅仅是假设如果使用 <code>ReentrantLock</code> “性能会更好”。请记住，这些是供高级用户使用的高级工具。（而且，真正的高级用户喜欢选择能够找到的最简单工具，直到他们认为简单的工具不适用为止。）。一如既往，首先要把事情做好，然后再考虑是不是有必要做得更快。</p>
<hr>
<p><code>Lock</code> 框架是同步的兼容替代品，它提供了 <code>synchronized</code> 没有提供的许多特性，它的实现在争用下提供了更好的性能。但是，这些明显存在的好处，还不足以成为用 <code>ReentrantLock</code> 代替 <code>synchronized</code> 的理由。相反，应当根据您是否 <em>需要</em> <code>ReentrantLock</code> 的能力来作出选择。大多数情况下，您不应当选择它 —— synchronized<br />
 工作得很好，可以在所有 JVM 上工作，更多的开发人员了解它，而且不太容易出错。只有在真正需要 <code>Lock</code> 的时候才用它。在这些情况下，您会很高兴拥有这款工具。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-10 08:42:39</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java中的ReentrantLock和synchronized两种锁机制的对比的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M69Eeob.html" rel="bookmark">java多线程之：Java中的ReentrantLock和synchronized两种锁定机制的对比 （转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:http://www.ibm.com/developerworks/cn/java/j-jtp10264/index.html 多线程和并发性并不是什么新内容,但是 Java 语言设计中的创新之一就是,它是第一个直接把跨平台线程模型和正规的内存模型集成到语言中的主流语言.核心类库包含一个 Thread 类,可以用它来构建.启动和操纵线程,Java 语言包括了跨线程传达并发性约束的构造 -- synchronized 和 volatile .在简化与平台无关的并发类的开发的同时,它决没有使并			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYjZJVp.html" rel="bookmark">ReentrantLock和synchronized两种锁定机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ReentrantLock和synchronized两种锁定机制 应用synchronized同步锁 把代码块声明为 synchronized,使得该代码具有 原子性(atomicity)和 可见性(visibility). 原子性意味着一个线程一次只能执行由一个指定监控对象(lock)保护的代码,从而防止多个线程在更新共享状态时相互冲突. 可见性类似volatile关键字. 应用ReentrantLock显示锁 ReentrantLock 类实现了 Lock ,它拥有与 synchronize			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwymEdM.html" rel="bookmark">java-请问：用Java代码中实现在一个类编写两种方法，下面的代码接下来怎么办呢？谢谢！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 请问:用Java代码中实现在一个类编写两种方法,下面的代码接下来怎么办呢?谢谢! 解决方案 啥东西,写两个方法,那你就写两个函数就行了,什么怎么办 解决方案二: 你的类里不就2个方法了吗			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQDnqp.html" rel="bookmark">如何理解java的这种方法，有两种get方法连在一起</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如何理解java的这种方法,有两种get方法连在一起 对象.get( ).getId( )==id 如何理解这条程序语句 如何理解java的这种方法,有两种get方法连在一起 解决方案 这种基本是list集合用的,,比如List中放一个User对象,,通过list.get(0).getId();这个指的就是取出list集合中的第一个对象的Id属性 解决方案二: 第一个get返回一个对象,它包含第二个方法,比如 class A { public int getid() { return			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGEaknM.html" rel="bookmark">Javascript和Java语言有什么关系？两种语言间的异同比较&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				虽然Javascript与Java有紧密的联系,但却是两个公司开发的不同的两个产品.Java是Sun公司推出的新一代面向对象的程序设计语言.特别适合于Internet应用程序开发:而Javascript是Sun与Netscape公司联合推出的产品,是为了扩展Netscape Navigator功能而开发的一种可以嵌入Web页面中的基于对象和事件驱动的解释性语言.且它的前身是Live Script,而Java的前身是Oak语言.下面就对两种语言间的异同作如下比较: (1)基于对象和面向对象 Jav			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgK7L5M.html" rel="bookmark">PowerShell中字符串分行显示的两种方法技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了PowerShell中字符串分行显示的两种方法技巧,本文直接给出代码实例,需要的朋友可以参考下 复制代码 代码如下: $a=&quot;1111111111111111111111101111111111111111111111111111111111111110111111111111111111011111 11111111111111111111111111111111111111111111111111111111111111111111111101111&quot; 字符串			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN1jXmb.html" rel="bookmark">用excel高级筛选中选择不重复记录两种方式的差异图解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  excel中高级筛选中选择不重复记录两种方式的差异 高级筛选分为两种方式 在原有区域显示筛选结果 将筛选结果复制到其他位置 在原有区域显示筛选结果被筛选掉的行只是被隐藏了 第二种方式 将筛选结果复制到其他位置 被筛选掉的行已经是被删除的 选中数据区域 观察这个数据区域中有两个行是有重复的 并且分别出现过两次 而且是挨着的 鼠标点按a1单元格 拖动鼠标到e25单元格 松开鼠标 点击菜单栏 数据 筛选 高级筛选命令 在弹出的高级筛选对话框的方式 选择为将筛选结果复制到其他位置 点击复制位置后面的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPLaDp.html" rel="bookmark">java对象转化-java中一个对象的属性可以有多少种</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java中一个对象的属性可以有多少种 java中一个对象的属性可以有多少种一个方法算是一个对象的行为,那么也就是它的对象了,是可以有无数种,还是有限制呢 解决方案 在程序代码中是没有限制,只能说性能还有需求 解决方案二: 在程序代码中是没有限制,只能说性能还有需求 解决方案三: 对象的属性没有限制			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdEZDNz.html" rel="bookmark">Java中，double类型的两个小数相减，值不正确</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Java中,double类型的两个小数相减,值不正确 double num1 = 0.03; double num2 = 0.02; double num; num = num1 - num2; 此时得到的num!= 0.01,而是等于0.0099....998:请问这是为什么啊?这是由于double类型的精度造成的嘛?谢谢. 解决方案 浮点数存储肯定有精度误差,特别是小数点后面,可以用BigDecemal这个类做			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWx5np.html" rel="bookmark" class="title">Photoshop制作魔幻风格的欧式女包海报</a>
					<div>
						这次演示案例的主题是欧式魔幻之旅,有了文案之后那就是有了方向,这时就开始从文案中发掘关键词(欧式,魔幻,之旅)有了这几个关键词,就可以按关键词开始找参考,以及要用到的素材. 最终效果 一.灵感的来源: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo0GEM.html" rel="bookmark" class="title">SQL Server 2005中Tempdb变化分析</a>
					<div>
						tempdb数据库是SQL Server用于临时或者开关操作的数据库.对tempdb所做的很多优化都是在透明的情况下,让处理加速,本文就介绍tempdb对SQL Server 2005的影响以帮助大家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pL4Wkp.html" rel="bookmark" class="title">PHP常量的定义</a>
					<div>
						常量可以理解为值不变的变量.常量值被定义后,在脚本的其他任何地方都不能被改变.一个常量由英文字母.下划线.和数字组成,但数字不能作为首字母出现. 在php中使用defaine()函数来定义常量,该函数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKWVdb.html" rel="bookmark" class="title">Windows 7虚拟化攻略之二：XP MODE部署</a>
					<div>
						上篇我们部署了RC版本的Windows 7,今天我们要在Windows 7上实现XP MODE.XP MODE实际上是一个XP SP3的虚拟机,这个虚拟机需要用Windows Virtual PC来加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AAZRp.html" rel="bookmark" class="title">在服务器安装sendmail及修改php&period;ini</a>
					<div>
						在服务器安装 sendmail sudo apt-get install sendmail 启动 sendmail sudo /etc/init.d/sendmail start 修改 php.ini ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBq1Kb.html" rel="bookmark" class="title">硬盘安装Windows Vista的方法</a>
					<div>
						事先准备:装好xp系统的电脑一台,vista安装iso. 注:(1).Windows Vista要求安装在NTFS分区,但是其他分区可以是FAT32格式! (2)简单无损NTFS转换方式:运行cmd进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW10jjz.html" rel="bookmark" class="title">两种设计模式在EJB开发中的应用</a>
					<div>
						摘要:本文介绍了J2EE的分层结构,深入研究了如何使用Session Facade模式和ValueObject 模式设计EJB,并对其开发过程做了较详细的说明. 关键字:EJB ;值对象模式;会话外观 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYjOKb.html" rel="bookmark" class="title">如何解决电脑共享打印连接错误</a>
					<div>
						  方法1: 1.被共享的打印机主机电脑需要开启Guest用护.右键点&quot;我的电脑&quot;选择&quot;管理&quot;-&quot;本机使用者和群组&quot;-&quot;使用者&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8mKqp.html" rel="bookmark" class="title">局域网怎么远程控制我的电脑</a>
					<div>
						在局域网中要远程控制电脑,建议将远端电脑的windows防火墙关掉,第三方软件的防火墙更不能开启: 再添加域用户权限(管理员除外).在远程电脑右击&quot;我的电脑&quot;,选择&quot;属性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJaeEp.html" rel="bookmark" class="title">环信举办首届O2O编程马拉松，诞生中国首个&OpenCurlyDoubleQuote;operator&rdquo;</a>
					<div>
						问题描述 6月6日至7日一场由中关村移动互联网产业联盟开发者云服务联委员会发起,环信联合大鱼自助游.本地科技.缘创派等举办的面向广大开发者的O2O编程马拉松大赛在大鱼自助游(fishtrip.cn)旗 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24EOop.html" rel="bookmark" class="title">PostgreSQL 10 内置分区 vs pg&lowbar;pathman</a>
					<div>
						标签 PostgreSQL , 内置分区 , pg_pathman , perf , 性能 , 锁 背景 PostgreSQL 10内置分区的性能不如pg_pathman分区插件的性能.有非常大的优化 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPkPDp.html" rel="bookmark" class="title">spring mvc-springmvc controller Mapping不能和方法Mapping一样&quest;</a>
					<div>
						问题描述 springmvc controller Mapping不能和方法Mapping一样? 方法名一样就404了,不一样就可以找到,为什么?如/goods/goods就不行,改为/goods/g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEy52z.html" rel="bookmark" class="title">Weex在千牛开放中的应用实践</a>
					<div>
						摘要:在2017年1月12日 Weex Conf 2017上,阿里巴巴商家事业部无线千牛团队的无灵结合阿里巴巴无限商家端的实际业务分享了Weex在千牛开放中的应用实践,本文分享了面对业务的各种挑战,无 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3mK8z.html" rel="bookmark" class="title">java--多线程之后台线程</a>
					<div>
						public class ThreadDaemon { /** * @param args * 后台线程在主进程结束后,也会退出 */ public static void main(String[] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NO8jM.html" rel="bookmark" class="title">csocket-CSocket类中OnReceive&lpar;&rpar;函数被重写后，为什么还要调用CSocket&colon;&colon;OnReceive&period;</a>
					<div>
						问题描述 CSocket类中OnReceive()函数被重写后,为什么还要调用CSocket::OnReceive. 1.CSocket类中OnReceive()函数被重写后,为什么还要调用CSock ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYDBBp.html" rel="bookmark" class="title">抵御云迁移风险 十大安全技巧汇总</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp; 现在,有很多公司开始考虑将现有应用程序.数据和基础架构迁移 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEex3M.html" rel="bookmark" class="title">在Ruby中处理XML和XSLT以及XPath的简单教程&lowbar;ruby专题</a>
					<div>
						什么是 XML ? XML 指可扩展标记语言(eXtensible Markup Language). 可扩展标记语言,标准通用标记语言的子集,一种用于标记电子文件使其具有结构性的标记语言. 它可以用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRD7jb.html" rel="bookmark" class="title">javascript中的Function&period;prototye&period;bind&lowbar;javascript技巧</a>
					<div>
						函数绑定(Function binding)很有可能是你在开始使用JavaScript时最少关注的一点,但是当你意识到你需要一个解决方案来解决如何在另一个函数中保持this上下文的时候,你真正需要的其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvmae5b.html" rel="bookmark" class="title">ORACLE sql 根据in查询里面数据的顺序进行排序</a>
					<div>
						select rownum||'' as id,t.materialname as prodCode,t.ename as prodName,t.materialtype||'_'||t.groupc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjw8yVM.html" rel="bookmark" class="title">启动智慧安全2&period;0巡讲 说说绿盟科技如何打破&OpenCurlyDoubleQuote;盒子思维&rdquo;</a>
					<div>
						作为一个&quot;安全盒子&quot;的主要提供商,绿盟科技近几年却对盒子说了&quot;不&quot;,当然并不是真的摒弃盒子,而是要打造盒子之上的全新安全能力. &quot;从主要提供盒子产品, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWGonM.html" rel="bookmark" class="title">Windows 8&period;1 新增控件之 DatePicker</a>
					<div>
						原文:Windows 8.1 新增控件之 DatePicker 大年初一来介绍一个简单易用的DatePicker 控件,这个控件是新增的?印象里很早就有了啊,Anyway来看看Windows 8.1  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnx10M.html" rel="bookmark" class="title">ubuntu oracle-ubuntu 13&period;10 怎么安装oracle 11g&quest;</a>
					<div>
						问题描述 ubuntu 13.10 怎么安装oracle 11g? 我的电脑似乎由于主板的问题不能安装12.04 只能安装13.10,可是13.10好像不能安装oracle数据库,有没有大神能解决这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBY34z.html" rel="bookmark" class="title">高分求助，如何获取特定电子邮箱里的信件及对应的数据</a>
					<div>
						问题描述 问题如下:比如有电子邮件:lovelife@xxx.com(此为企业邮箱),会不定时的收到客户发过来的信息!现想写一段程序,实时的监控这个邮箱,如有收到新邮件,则获取里面对应的文件资料!问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGr2BEp.html" rel="bookmark" class="title">胡延平：上市将让当当在电商领域站稳脚跟</a>
					<div>
						DoNews 12月8日消息 DCCI互联网数据中心总经理胡延平在接受采访时表示,当当网上市能为这家电子商务老企业注入资金和活力,有利于其在电子商务领域站稳脚跟. 胡延平认为,当当作为十年老店成功上市 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr23OOM.html" rel="bookmark" class="title">易到用车越用越省钱</a>
					<div>
						易到用车,作为中国互联网用车第一平台,于7月1日悄然上线新的车型--Lucky Car,上线首日,订单就供不应求. 作为一款定位优化用车体验.回馈易到用户的新车型,是其尝试新的运营模式的又一探索.让更 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKamjM.html" rel="bookmark" class="title">关于datagridview的问题&period;</a>
					<div>
						问题描述 关于datagridview的问题. 请问如何在datagridview中输入第1,2,3列后,自动通过查询数据库表输出后面的列??? 我现在会在第一列输入数据,然后从DB中读出后面的列,但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAk3XXz.html" rel="bookmark" class="title">Equifax因Struts漏洞未及时打补丁 面临4500亿美元集体诉讼赔偿</a>
					<div>
						征信公司Equifax值不值得信任?个人数据放那里保不保险?这些问题的答案似乎越来越明朗了.该公司不仅遭受了史上最大数据泄露--1.43亿人的姓名.社会安全号.家庭住址等信息被黑,其各种安全漏洞还在不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/z7wYZZz.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vbW1iaXoucXBpYy5jbi9tbWJpei85UFhaN21NUVQxd1JXVEJUMUhkVVcwR2VGMUFiRGNrTWExMlF5cHg2QjZzOUN4UldLSWxrMHEzbUUxM1RKMkhQRGVNU2hwdEVjWTV0YTlucnlLUkZLdy82NDA=.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/z7wYZZz.html" rel="bookmark" class="title">全球最有意思的20家传感器公司</a>
					<div>
						对于&quot;物联网(Internet of Things)&quot;来说,传感器是不可或缺的重要组成.大多数物联网设备都带有传感器,以记录环境变化,并相应作出反馈.可以说,传感器就像是物联网设备 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdvE56b.html" rel="bookmark" class="title">Sync Framework Toolkit 开源库</a>
					<div>
						Sync Framework Toolkit构建在Sync Framework 2.1之上,使用OData在所有平台或客户端--包括Windows Phone 7.Silverlight.Window ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjojkWM.html" rel="bookmark" class="title">WPF中Image控件不释放内存</a>
					<div>
						问题描述 使用Image控件和button控件,每次按一下button载入一张新图片,就是不断修改Image控件的source.但是程序占的内存越来越多,似乎Image控件显示之前的图片所占的资源并没 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
